%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [distanceMatrix] = selectEdgesForSFSDP(sDim,noOfSensors,distanceMatrix,minDegree,ubdForSenToAnchorEdge)

% startingTime = tic; 
[rowSize,colSize] = size(distanceMatrix);
noOfAnchors = colSize - noOfSensors; 

% Reordering sensors randomly --->
sensorDistMat = distanceMatrix(:,1:noOfSensors)+distanceMatrix(:,1:noOfSensors)'; 
rand('state',3202); 
[temp,permutation] = sort(rand(1,noOfSensors));
[temp,invPermutation] = sort(permutation);
sensorDistMat = sensorDistMat(permutation,permutation); 
distanceMat2 = [sensorDistMat,distanceMatrix(permutation,noOfSensors+1:colSize)];
distanceMat2 = triu(distanceMat2,1);
% <--- Reordering sensors randomly 
% clear distanceMatrix

% fprintf('##0 %6.1f\n',toc(startingTime));
% startingTime = tic; 

% Selecting edges between sensors and anchors 
% ---> 
senToAnchorDistMat = sparse(rowSize,noOfAnchors); 
countVector = sparse(1,rowSize); 
for r=1:noOfAnchors
    nzIdx = find(distanceMat2(:,noOfSensors+r)' > 0); 
    if ~isempty(nzIdx)
        for p=nzIdx
            if (countVector(p) < ubdForSenToAnchorEdge)
                senToAnchorDistMat(p,r) = distanceMat2(p,noOfSensors+r); 
                countVector(p) = countVector(p) + 1;
            end
        end
    end
end
% < ---
% Selecting edges between sensors and anchors 

% fprintf('##1 %6.1f\n',toc(startingTime));
% startingTime = tic; 

% Selecting edges between sensors and anchors 
% ---> 
countVector = min([countVector;repmat(sDim,1,noOfSensors)],[],1);
noOfEffectiveDegrees = sum(countVector); 
totalDegrees = noOfSensors*minDegree; 
[nzzRowIdx,nzzColIdx,nzzValue] = find(distanceMat2(:,1:noOfSensors)'); 
% clear distanceMat2
noOfNzz = length(nzzRowIdx); 
if noOfNzz == 0
    fprinrf('## no edges between sensors\n');
    
else
    selRowIdx = [];
    selColIdx = [];
    selValue  = [];
    k = 0;
    while (noOfEffectiveDegrees < totalDegrees) && (k < noOfNzz)
        k = k+1;
        p = nzzRowIdx(k);
        q = nzzColIdx(k);
        if (countVector(1,p) < minDegree)
            selRowIdx = [selRowIdx;p];
            selColIdx = [selColIdx;q];
            selValue  = [selValue;nzzValue(k)];
            countVector(p) = countVector(p)+1;
            noOfEffectiveDegrees = noOfEffectiveDegrees+1;
            if (countVector(1,q) < minDegree)
                countVector(q) = countVector(q)+1;
                noOfEffectiveDegrees = noOfEffectiveDegrees+1;
            end
        elseif (countVector(1,q) < minDegree)
            selRowIdx = [selRowIdx;p];
            selColIdx = [selColIdx;q];
            selValue  = [selValue;nzzValue(k)];
            countVector(q) = countVector(q)+1;
            noOfEffectiveDegrees = noOfEffectiveDegrees+1;
        end
    end
    distanceMat2 = ...
        [sparse(selRowIdx,selColIdx,selValue,noOfSensors,noOfSensors)',...
        senToAnchorDistMat];
end

% fprintf('##2 %6.1f\n',toc(startingTime));
% startingTime = tic; 


distanceMat2(:,1:noOfSensors) = distanceMat2(:,1:noOfSensors) + distanceMat2(:,1:noOfSensors)';

distanceMatrix = [distanceMat2(invPermutation,invPermutation),distanceMat2(invPermutation,noOfSensors+1:colSize)];
distanceMatrix = triu(distanceMatrix,1); 
distanceMatrix = sparse(distanceMatrix);

% fprintf('##3 %6.1f\n',toc(startingTime));
% 
% XXXXX

return
%%%%% end of selectEdgesForSFSDP2 %%%%%
